<template>
  <div id="app">
    <nav>
      <div class="nav-wrapper grey darken-3">
        <a href="#" class="brand-logo center  " >Hepta Shop</a>
        <img src="img/hepta-logo.png"/>
      </div>
    </nav>

    <div class="container">
      <form @submit.prevent="salvar">
        <label>Nome</label>
        <input type="text" placeholder="Nome" v-model="produto.nome" />
        <label>Fabricante</label>
        <input type="text" placeholder="Fabricante" v-model="produto.fabricante" />
        <label>Valor</label>
        <input type="number" placeholder="Valor" v-model="produto.valor" />
        <label>Estoque</label>
        <input type="text" placeholder="Estoque" v-model="produto.estoque" />

        <button class="waves-effect waves-light btn-small">
          Salvar
          <i class="material-icons left">save</i>
        </button>
      </form>

      <table>
        <thead>
          <tr>
            <th>Nome</th>
            <th>Fabricante</th>
            <th>Valor</th>
            <th>Estoque</th>
          </tr>
        </thead>

        <tbody>
          <tr v-for="produto of produtos" :key="produto.id">
            <td>{{ produto.nome }}</td>
            <td>{{ produto.fabricante }}</td>
            <td>{{ produto.valor }}</td>
            <td>{{ produto.estoque }}</td>

            <td>
              <button @click="editar(produto)" class="waves-effect btn-small blue darken-1">
                <i class="material-icons">create</i>
              </button>
              <button @click="remover(produto)" class="waves-effect btn-small red darken-1">
                <i class="material-icons">delete_sweep</i>
              </button>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
  </div>
</template>

<script>
import Produto from "./services/produtos";
export default {
  data() {
    return {
      produto: {
        id: "",
        nome: "",
        fabricante: "",
        valor: "",
        estoque: ""
      },

      produtos: []
    };
  },

  mounted() {
    this.listar();
  },

  methods: {
    listar() {
      Produto.listar().then(resposta => {
        this.produtos = resposta.data;
      });
    },
    salvar() {
      if (!this.produto.id) {
        Produto.salvar(this.produto)
          .then(resposta => {
            this.produto = {};
            alert("Salvo com Sucesso!", resposta);
            this.listar();
            this.erros = [];
          })
          .catch(e => {
            this.erros = e.response.data.errors;
          });
      } else {
        Produto.atualizar(this.produto)
          
          .then(resposta => {
            this.produto = {};
            alert("Atualizado com Sucesso!", resposta);
            this.listar();
            this.erros = [];
          })
          .catch(e => {
            this.erros = e.response.data.errors;
          });
      }
    },

    editar(produto) {
      this.produto = produto;
    },

    remover(produto) {
      if (confirm("Deseja excluir o produto?")) {
        Produto.apagar(produto)
          .then(resposta => {
            this.listar();
            this.errors = {};
            alert("deletado com Sucesso!", resposta);
          })
          .catch(e => {
            this.errors = e.response.data.errors;
          });
      }
      this.produto = [];
    }
  }
};
</script>


<style>
</style>
